/****************************************************************************/
/*                                                                          */
/*  Xmenu  1998-2000 Jrme Grimbert                                       */
/*  -----                                                                   */
/*                                                                          */
/*  Jrme Grimbert remains the author and owner of this file and of all    */
/*  related works for the application of the copyright law and other rights.*/
/*  The use or distribution of this file proclaims the acceptation of this  */
/*  licence.                                                                */
/*  The use of this file and the relevant library is free, and at the risks */
/*  of the user.                                                            */
/*  This file and the relevant library can be distributed freely,           */
/*  at absolutely no cost.                                                  */
/*  Distribution on the internet is free and should never require any       */
/*  registration or identification when using the HTTP protocol.            */
/*  Ftp servers are free to offer access to this file and the related others*/
/*  files to all users, including the anonymous account.                    */
/*  Distribution with a charge may occur only with a prior written agreement*/
/*  between the distributor and Jrme Grimbert. In this particular case    */
/*  the distributor should expect to provide an absolutely free of charge   */
/*  copy of the media collection this file is included in. The exact        */
/*  definition of the collection is part of the negociation.                */
/*  In all case, the French laws and court rules will apply and prevail.    */
/*  The court of Versailles (France) will be the final referer.             */
/*                                                                          */
/*  Jrme Grimbert est l'auteur de ce fichier et de tout les fichiers qui  */
/*  y sont rattachs pour l'application de la convention de Berne et de la  */
/*  loi sur la proprit intellectuelle.                                    */
/*  L'usage ou la distribution de ce fichier entrane l'acceptation de      */
/*  cette license.                                                          */
/*  L'usage de ce fichier et des fichiers rattachs est libre, et aux       */
/*  risques et prils de l'utilisateur.                                     */
/*  La distribution est libre et gratuite.                                  */
/*  La distribution sur internet est libre et ne doit ncessiter aucun      */
/*  enregistrement ou identification lors de l'usage du protocole HTTP.     */
/*  Les serveurs FTP sont libres d'offrir l'accs  ce fichier ainsi qu'aux */
/*  fichiers y sont rattachs  tous les utilisateurs, y compris en accs   */
/*  anonyme.                                                                */
/*  Une distribution payante peut exister seulement avec un accord crit    */
/*  pralable entre le distributeur et Jrme Grimbert. Dans ce cas prcis  */
/*  le distributeur peut s'attendre  devoir fournir entirement            */
/*  gratuitement une copie de la collection dans laquelle se trouve ce      */
/*  fichier. La dfinition exacte du terme de collection fait partie de     */
/*  la ngociation.                                                         */
/*  Dans tout les cas, c'est la loi franaise qui s'appliquera et prvaudra.*/
/*  Le tribunal de Versailles (France) est le tribunal de rfrence.        */
/*                                                                          */
/*  Jrme Grimbert      ( au 03/08/2000 )                                  */
/*  1 Alle Louis Roveyaz                                                   */
/*  78140 Vlizy-Villacoublay                                               */
/*  France                                                                  */
/*                                                                          */
/*  jgrimbert@atos-group.com                                                */
/*                                                                          */
/****************************************************************************/

#include "xmenu_h"
#include "xmenudef_h"

#include <stdarg.h>
#include <stdlib.h>
#include <qptr.h>
#include <qdos.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#define bord_x 4

#define FORM_Q40 0x0221
#define FORM_QXL 0x0220
#define FORM_256 0x0210
#define FORM_P256 0x021F


extern long jg_paper,jg_ink,jg_border,jg_filling,jg_surround,jg_spaper,jg_sink;
extern long jg_bborder, jg_bpaper, jg_bink, jg_upaper, jg_uink;
extern long jg_iink, jg_ipaper;


static void place_item(const long nitem,
                             struct WM_litm litem[],
                       const long char_size,
                       const long item_width,
                       const long current_window_width,
                             long *vert,
                             long *hori,
                             struct WM_action * afunc,
                       const long xoff,
                       const long yoff
                      )
{
   long vertical,horizon,i;
   vertical = (long)sqrt((double)nitem);
   horizon = (nitem + vertical -1) / vertical;

   /*
   ** We are loosing room for nothing already
   ** --> avoid that
   */
   i = current_window_width / (item_width+bord_x);
   if (i > horizon)
   {
      horizon = i;  /* vertical will be dealed later */
   }

   /* but, if item_width * horizon is far more than vertical
   ** then increase vertical and do it again
   ** unless, of course, there would be no gain due to the
   ** current window width
   */
   while ((horizon*item_width > vertical*char_size*5 )
        &&(horizon*(item_width+bord_x) > current_window_width)
         )
   {
   vertical++;
   horizon = (nitem + vertical -1) / vertical;
   };
   /* That's nice, but may be we can reduce vertical
   ** without increasing horizon
   ** (so as to use the best of the last column)
   */
   while ( horizon* (vertical -1) >=nitem)
   {
   vertical--;
   }

   for(i=0;i<nitem;i++)
   {
      litem[i].xsize = item_width;
      litem[i].ysize = 12;
      litem[i].xorg = (i / vertical) * (item_width +bord_x) + xoff;
      litem[i].yorg = (i % vertical) * 14 + yoff;
      litem[i].xjst = 0;
      litem[i].yjst = 0;
      litem[i].type = TYP_TEXT;
      litem[i].skey = 0;
      litem[i].item = i;
      litem[i].pact = afunc;
   }

   *vert = vertical;
   *hori = horizon;
}

static void text_size(char * string, long *x , long *y)
{
char *cursor;
long i;
cursor = string;
*x = i = 0;
*y = 0;
while (*cursor)
{
i++;
if (*cursor == '\n')
  {
  i = 0;
  *y += 1;
  }
if ( *x < i )
  {
   *x = i;
  }
cursor++;
}

}



static long ACHOICE(
 struct WM_wwork *wwk,
 struct WM_litm *li,
 struct WM_wstat *wst
)
{
   /* Item_Select_Choice=li->item; */ /* set item hit in status area */
   wwk->wstat->litem[li->item]=(char)WSI_MKSL;
   wm_ldraw(wwk,-1);
   return PT__CAN;                  /* and return CAN event */
}

static long ALIST(
 struct WM_wwork *wwk,
 struct WM_litm *li,
 struct WM_wstat *wst
)
{
/*
    if ( wwk->wstat->litem[li->item] & WSI_SLCT )
    {
       wwk->wstat->litem[li->item] = (char)WSI_MKAV;
    }
    else
    {
       wwk->wstat->litem[li->item] = (char)WSI_MKSL;
    }
*/
    wm_ldraw(wwk,-1);
    if (wst->kprs==K_DO)
   {
   return PT__CAN;
   }
   else
   {
   return AHIT_NORMAL;
   }

}
static long ARADIO(
 struct WM_wwork *wwk,
 struct WM_litm *li,
 struct WM_wstat *wst
)
{
   long i;
   for(i=0;i<wwk->nlitm;i++)
   {
   if ((wwk->wstat->litem[i] == (char)WSI_SLCT )
     ||(wwk->wstat->litem[i] == (char)WSI_MKSL )
      )
     {
      wwk->wstat->litem[i]=(char)WSI_MKAV;
     }
   }
   wwk->wstat->litem[li->item]=(char)WSI_MKSL;
   wm_ldraw(wwk,-1);
   if (wst->kprs==K_DO)
   {
   return PT__CAN;
   }
   else
   {
   return AHIT_NORMAL;
   }
}

static long AMOVE(
              struct WM_wwork *wwk
)
{
   short dx,dy;
   wwk->wstat->evnt |= PT_WMOVE;   /* set event bit for wm_chwin */
   wm_chwin (wwk,&dx,&dy);         /* move window */
   return AHIT_NORMAL; /* and return, not significant */
}


static long ABWAKE (
               struct WM_wwork *wwk,
               struct WM_litm *li,
               struct WM_wstat *wst,
               short xpos,
               short ypos,
               short key,
               short event
)  /* all this just to get the event! */
{
   if (event) return PT__WAKE;        /* convert DO to WAKE */
   if (wwk->flag) return AMOVE (wwk); /* else if not in frame, standard move */
   wwk->wstat->litem[0] = WSI_MKAV;   /* set make available */
   wm_ldraw (wwk,-1);            /* and re-draw */
   wm_wdraw(wwk);
   return AHIT_NORMAL;
}



static struct WM_action achoice = { JSR, wm_actli, ACHOICE };
static struct WM_action aradio = { JSR, wm_actli, ARADIO };
static struct WM_action amove = { JSR, wm_actli, AMOVE };
static struct WM_action abwake = { JSR, wm_actli, ABWAKE };
static struct WM_action alist = { JSR, wm_actli, ALIST };

/*
**
** Get_NativeForm()
**
** return value: an unsigned short which is the Form word for native sprite/blob/pattern
*/
unsigned short Get_NativeForm()
{
   short mode,type;
   mode = -1;
   type = -1;
   mt_dmode(&mode, &type);

   switch(mode)
   {
      case 0: return FORM_QL4; break;
      case 8: return FORM_QL8; break;
      case 32: return FORM_QXL; break;
      case 33: return FORM_Q40; break;
   }
   return FORM_QL4;
}

/*
**
** Get_GraphicInfo : sprite : a sprite definition
**                   pxsize : address of an unsigned short, will contain the x-size
**                   pysize : address of an unsigned short, will contain the y-size
**                   pxorg  : address of an unsigned short, will contain the x-org
**                   pyorg  : address of an unsigned short, will contain the y-org
*/
void Get_GraphicInfo(
                          const struct WM_sprite * picture,
                          unsigned short *xsize,
                          unsigned short *ysize,
                          unsigned short *xoff,
                          unsigned short *yoff
                          )
{
   unsigned short extra_mode;
   unsigned short wmode;
   struct WM_sprite * cursor;
   char * anyptr;

   wmode = ( Get_CharSize() == 6 ? FORM_QL4 : FORM_QL8);
   extra_mode = Get_NativeForm();
   /* now, let's get the sprite size */
   *xoff=*xsize=*ysize=*yoff=0;
   cursor = (struct WM_sprite *) picture;
   while(cursor)
   {
   if ((cursor->form == wmode)||(cursor->form == extra_mode)||
       ( ( extra_mode & 0x0200 )&&
         ((cursor->form == FORM_256)||(cursor->form == FORM_P256))
       ))
      {
      *xsize= cursor->xsize;
      *ysize= cursor->ysize;
      *yoff=cursor->yorg;
      *xoff=cursor->xorg;
      if (cursor->form == extra_mode)
         {
         return;
         }
      }
   if (cursor->next)
      {
      anyptr = (char *)cursor;
      anyptr += cursor->next + sizeof(WM_sprite_t) - sizeof(long);
      cursor = (struct WM_sprite *)anyptr;
      }
   else
      {
      cursor = NULL;
      }
   };

}
 


/*
** Item_Select : color_code : for paper and ink
**               title      : a string that will be used as the title
**                            of the pop-up window
**               explanation: a string that explain the choice
**               nitem      : number of choice
**               ...        : a string, each one describing a possible
**                            choice.
**
** return value:
**               -1 : ESC was used to exit the window
**                n : choice number n was choosen
**
*/




long Item_Select(
                 const colourSet * color_code,
                 const char *   title,
                 const char *   explanation,
                 const long     nitem,
                 const char * litm0, ...)
{
   va_list nxlitm;
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;

   struct WM_wstat  *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };

   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;
   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;

   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);

   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infx[0].ysize = y_expl * 10 + 10;
   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;
   infw[2].ysize = y_expl * 10 + 10;

   x=y=item_width=0;
   for(va_start(nxlitm, nitem),i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=va_arg(nxlitm,char *);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width, window_width, &vertical, &horizon, &achoice, bord_x, 30+y_expl * 10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl * 10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

 /*  Item_Select_Choice = -1;  */
   ret_value = -1;

   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   for(i=0;i<nitem;i++)
   {
      if (ws->litem[i] & WSI_SLCT)
      {
         ret_value = i;
         i = nitem;
      }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);

   return ret_value;
}

/*
** Item_Select_Array : color_code : for paper and ink
**                     title      : a string that will be used as the title
**                                  of the pop-up window
**                     explanation: a string that explain the choice
**                     nitem      : number of choice
**                     array      : an array of strings, each one describing
**                                  a possible choice.
**
** return value:
**               -1 : ESC was used to exit the window
**                n : choice number n was choosen
**
*/

long Item_Select_Array(
                 const colourSet *   color_code,
                 const char *        title,
                 const char *        explanation,
                 const long          nitem,
                 const char **       array
                )
{
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;

   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;
   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;

   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);

   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infx[0].ysize = y_expl * 10 + 10;
   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;
   infw[2].ysize = y_expl * 10 + 10;

   x=y=item_width=0;
   for(i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=(char *)(array[i]);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width, window_width, &vertical, &horizon, &achoice, bord_x, 30+y_expl * 10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl * 10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

 /*  Item_Select_Choice = -1;  */
   ret_value = -1;

   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   for(i=0;i<nitem;i++)
   {
      if (ws->litem[i] & WSI_SLCT)
      {
         ret_value = i;
         i = nitem;
      }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);
   return ret_value;
}



/*
** Message_Report : color_code : for paper and ink
**                  message    : a string to display as an item
**
*/

void Message_Report(
                    const colourSet * color_code,
                    const char * message
                   )
{
   va_list nxlitm;
   short char_size;
   long string_length;
   JG_text * toto;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   long curs_len;
   long x_expl;
   long y_expl;

   struct WM_wstat * ws; /* this time ws is initialised in code */
   long i;

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[1+1] =  /* information window */
   {
    {0,10,          /* xsize, ysize         size */
     bord_x,bord_x,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     1,1,infw,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat));
   if (!ws) { return ; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);

   curs_len= strlen(message);
   toto = malloc(curs_len+sizeof(JG_text));
   infx[0].pobj = toto;
   QD_STXT((*toto), message, curs_len);
   text_size(message, &x_expl, &y_expl);

   item_width = x_expl * char_size + 2 * bord_x;


     infw[0].xsize = infx[0].xsize = item_width;
     infw[0].ysize = infx[0].ysize = y_expl * 10 + 12;
   window_width = (item_width) + (bord_x) * 2 ;
   infw[0].papr = color_code->paper;
   infx[0].attr.t.ink = color_code->ink;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = (y_expl*10) +12+ (bord_x)*2;
   ww.xorg = window_width /2;
   ww.yorg = 6 + bord_x;
   ww.curc = color_code->surround ;



   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
         if (ws->evnt & PT_DO) break;
      };
   }
   wm_cluns(&ww);

   free(toto);
   free(ws);
}


/*
** String_Edit : color_code     : for paper and ink
**               title          : a string that will be used as the title
**                                of the pop-up window
**               explanation    : a string that explain the entry
**               default_value  : a suggestion for the entry
**               max_length     : the maximal length of the entry
**               value          : the entry
**
** return value:
**               -1 : ESC was used to exit the window
**                n : the length of the entry
**
*/

long String_Edit(
                 const colourSet *  color_code,
                 const char * title,
                 const char * explanation,
                 const char * default_value,
                 const long   max_length,
                       char * value
                )
{

   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   JG_text * toto;
   short window_width;
   short item_width;
   short x,y;
   long curs_len;
   long x_expl;
   long y_expl;


   struct WM_wstat * ws; /* this time ws is initialised in code */
   long i;
   long ret;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info inft[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   
   static struct WM_infw infw[4+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{0,10,          /* xsize, ysize         size */
     bord_x,28,           /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     inft}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     4,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat));
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);

   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;

   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);

   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infx[0].ysize = infw[2].ysize = 12 + y_expl * 10;
   infw[3].yorg = 28 + y_expl * 10;
   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;

      curs_len= strlen(default_value);
      if (curs_len > max_length)
      {
         curs_len = max_length;
      }
      toto = malloc(max_length+sizeof(QD_text_t));
      QD_STXT((*toto), default_value, curs_len);
      inft[0].pobj=toto;

         item_width = (max_length+1) * char_size;
     item_width += 4; /* allow for border */
      inft[0].attr.t.ink = color_code->ink;
      inft[0].xsize = item_width;
      infw[3].xsize = item_width;
      infw[3].papr = color_code->paper;


   if (window_width < (item_width + (bord_x) * 2 ) )
   {
   window_width = item_width + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 3;
   ww.pinfo = infw;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = 40+ y_expl * 10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);
   wm_swinf (&ww,3,CL_IINK);
   wm_rname (ww.chid, (struct QD_text *)toto); /* read text */
   }
   memcpy(value,&(toto->chrs),ret = toto->len);
   value[ret]='\0';
   wm_cluns(&ww);

   free(toto);
   free(titre);
   free(explain);
   free(ws);
   return ret;
}


/*
** XDialog : color_code  : for paper and ink
**           title       : a string that will be used as the title
**                         of the pop-up window
**           message     : a string that explain the choice
**           picture     : a logo to display on the left side of the message
**           help_avail  : null if no help option, not null if help option is available
**
** return value:
**               -1 : ESC was used to exit the window
**                0 : The ok option was choosen
**                1 : The cancel option was choosen
**                2 : The help option was choosen
**
*/

long XDialog(
             const colourSet * color_code,
             const char      * title,
             const char      * message,
             const struct WM_sprite * picture,
             const long        help_avail
            )
{
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   QD_TEXTI(ok,"Ok");
   QD_TEXTI(cancel,"Cancel");
   QD_TEXTI(help,"Help");
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   long curs_len;
   long vertical;
   long nitem;
   unsigned short xsize,xoff,ysize,yoff;
   char * anyptr;
   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;
   long x_expl,y_expl;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,                /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infp[1+1] =   /* information objects */
   {
    {0,0,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_SPRITE,0,          /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[4+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */

    ,{0,0,          /* xsize, ysize         size */
     0,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infp}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat));
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;


   char_size = Get_CharSize();
   nitem = help_avail ? 3 : 2;
   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   /* now, let's get the sprite size */
   xoff=xsize=ysize=yoff=0;
   Get_GraphicInfo(picture, &xsize, &ysize, &xoff, &yoff);

   if ((xsize == 0) || (ysize == 0))
   {
      return -1;
   }
   xsize = (xsize+1) & 0xFFFE;
   infp[0].pobj = (struct WM_sprite *)picture;
   infp[0].xsize = xsize;
   infp[0].ysize = ysize;
   infp[0].xorg = 0;
   infp[0].yorg = 0;
   infw[3].xsize = xsize;
   infw[3].ysize = ysize;
   infw[3].xorg = 0;
   infw[3].yorg = 14;

   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;

   string_length = strlen(message);
   text_size(message, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),message,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 3 *(bord_x) + xsize;



   if (window_width < string_length )
   {
      window_width = string_length;
   }
   if (ysize < (10+10*y_expl))
   {
      ysize = 10 + 10*y_expl;
   }
   infx[0].xsize = string_length - 2*(bord_x) -xsize ;
   infw[2].ysize = infx[0].ysize = 10+10*y_expl;
   infx[0].attr.t.ink = color_code->ink;
   infw[3].papr = color_code->paper;
   infw[2].papr = color_code->paper;
   infw[2].xorg = xsize + bord_x;
   infw[2].xsize = infx[0].xsize;

   vertical = (long)sqrt((double)nitem);
   x=y=item_width=0;
   litem[0].pobj = &ok;
   litem[1].pobj = &cancel;
   if (nitem > 2)
   {
      litem[1].pobj = &help;
      litem[2].pobj = &cancel;
   }
      ws->litem[0]= ws->litem[1] = ws->litem[2] = 0;

         item_width = 7 * char_size; /* Cancel */

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */
   horizon = (nitem + vertical -1) / vertical;

   for(i=0;i<nitem;i++)
   {
      litem[i].xsize = item_width;
      litem[i].ysize = 12;
      litem[i].xorg = (i % horizon) * (item_width +bord_x) + (bord_x);
      litem[i].yorg = (i / horizon) * 14 + 18 + ysize;
      litem[i].xjst = 0;
      litem[i].yjst = 0;
      litem[i].type = TYP_TEXT;
      litem[i].skey = 0;
      litem[i].item = i;
      litem[i].pact = &achoice;
   }
   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 3;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 20 + ysize;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;


   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   ret_value = -1;
   for(i=0;i<nitem;i++)
   {
      if (ws->litem[i] & WSI_SLCT)
      {
         ret_value = i;
         i = nitem;
      }
   }
   wm_cluns(&ww);

   free(litem);
   free(titre);
   free(explain);
   free(ws);
   return ret_value;
}

/*
** Menu_Button_Text : color_code  : for paper, ink and border
**                    main_window : the working main window that will be hidden
**                    title       : the text to use for the button
**
*/

void Menu_Button_Text(
                      const colourSet * color_code,
                            struct WM_wwork * main_window,
                      const char *     title
                     )
{
   short sleep_wid;
   long string_length;

   JG_text * titre;

   struct WM_wstat *ws; /* this time ws is initialised in code */

   static struct WM_litm litm[1+1] =   /* loose item */
   {
    {12,10,                 /* xsize, ysize         size */
     2,1,                   /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,K_WAKE,       /* type, skey           type and select key */
     NULL,               /* *pobj                pointer to object */
     0,                     /* item                 item number */
     &abwake                /* *pact                pointer to action */
    },
    {-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     16,12,                 /* xsize, ysize         size */
     12,8,                  /* xorg, yorg           and origin */
     2,                     /* flag                 no clear + shadow */
     1,CL_BBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_BPAVBL,CL_BIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_BPSLCT,CL_BISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     0,0,NULL,              /* ninfo, ninob, *pinfo info winds */
     1,litm,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };

   ws = malloc(sizeof(struct WM_wstat));
   if (!ws) { return ; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   ww.chid= main_window->chid; /* copy channel ID */

   string_length = strlen(title);
   titre = malloc(string_length + sizeof(QD_text_t));
   QD_STXT((*titre), title, string_length);      /* title string */
   litm[0].pobj = titre;
   sleep_wid = (((string_length * Get_CharSize()) +3) & 0xfffc);
         /* round up to multiple of 4 */

   ww.xsize = sleep_wid+4;          /* allow for loose item border */
   ww.xorg = sleep_wid-4;           /* pointer here */
   ww.yorg = 9;

   litm[0].xsize = sleep_wid;       /* set item size */
   ws->litem[0] = 0;                 /* and status */

   ws->citem = -1;                   /* no current item  */
   ws->ciact = NULL;                 /* or current item routine */
   ww.borc = color_code->button_border;
   ww.papr = color_code->button_paper;
   ww.aback = color_code->button_paper;
   ww.aink  = color_code->button_ink;
   ww.sback = color_code->button_paper;
   ww.sink  = color_code->button_ink;
   ww.curc = color_code->button_ink ;

   wm_unset (main_window);                  /* unset old definition */

   if (bt_prpos (&ww))              /* set into button frame? */
   {  ww.flag = 2;                  /* ... no, use shadow */
      wm_prpos (&ww,-1,-1); }          /*     and position at pointer */

   wm_wdraw (&ww);                  /* and draw */
   
   while (!wm_rptr(&ww)) {if (ws->evnt & PT_WAKE) break;}
   
   wm_unset (&ww);                  /* unset button */

   if (!ww.flag) bt_free();           /* free button */

   free(titre);
   free(ws);
   main_window->xorg = main_window->wstat->ptpsx - main_window->xorg;
   main_window->yorg = main_window->wstat->ptpsy - main_window->yorg;
   /* set "origin" to window rel pos */
   wm_prpos (main_window,
             main_window->wstat->ptpsx,
             main_window->wstat->ptpsy
            ); /* old window position */
   wm_wdraw (main_window);                  /* and draw */



}
/*
** Menu_Button_Logo : color_code  : for paper and border
**                    main_window : the working main window that will be hidden
**                    picture     : the sprite to use for the button
**
*/

void Menu_Button_Logo(
                      const colourSet * color_code,
                            struct WM_wwork *  main_window,
                      const struct WM_sprite * picture
                     )
{
   unsigned short xsize,xoff,ysize,yoff;
   char * anyptr;
   long char_size;

   struct WM_wstat *ws; /* this time ws is initialised in code */

   static struct WM_litm litm[1+1] =   /* loose item */
   {
    {12,10,                 /* xsize, ysize         size */
     2,1,                   /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_WAKE,       /* type, skey           type and select key */
     NULL,               /* *pobj                pointer to object */
     0,                     /* item                 item number */
     &abwake                /* *pact                pointer to action */
    },
    {-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     16,12,                 /* xsize, ysize         size */
     12,8,                  /* xorg, yorg           and origin */
     2,                     /* flag                 no clear + shadow */
     1,CL_BBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_BPAVBL,CL_BIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_BPSLCT,CL_BISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     0,0,NULL,              /* ninfo, ninob, *pinfo info winds */
     1,litm,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };

   ws = malloc(sizeof(struct WM_wstat));
   if (!ws) { return ; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;


   ww.chid= main_window->chid; /* copy channel ID */

   char_size = Get_CharSize();
   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   /* now, let's get the sprite size */
   xoff=xsize=ysize=yoff=0;
   Get_GraphicInfo(picture,&xsize,&ysize,&xoff,&yoff);

   if ((xsize == 0) || (ysize == 0))
   {
      return;
   }
   xsize = (xsize+1)& 0xFFFE;

   litm[0].pobj = (void *)picture;

   ww.xsize = xsize+4;          /* allow for loose item border */
   ww.ysize = ysize+2;
   ww.xorg = 4;           /* pointer here */
   ww.yorg = 2;

   litm[0].xsize = xsize;       /* set item size */
   litm[0].ysize = ysize;
   ws->litem[0] = 0;                 /* and status */

   ws->citem = -1;                   /* no current item  */
   ws->ciact = NULL;                 /* or current item routine */
   ww.borc = color_code->button_border;
   ww.papr = color_code->button_paper;
   ww.aback = color_code->button_paper;
   ww.aink  = color_code->button_ink;
   ww.sback = color_code->button_paper;
   ww.sink  = color_code->button_ink;
   ww.curc = color_code->button_ink ;

   wm_unset (main_window);                  /* unset old definition */

   if (bt_prpos (&ww))              /* set into button frame? */
   {  ww.flag = 2;                  /* ... no, use shadow */
      wm_prpos (&ww,-1,-1); }          /*     and position at pointer */

   wm_wdraw (&ww);                  /* and draw */
   
   while (!wm_rptr(&ww)) {if (ws->evnt & PT_WAKE) break;}
   
   wm_unset (&ww);                  /* unset button */

   if (!ww.flag) bt_free();           /* free button */
   free(ws);
   main_window->xorg = main_window->wstat->ptpsx - main_window->xorg;
   main_window->yorg = main_window->wstat->ptpsy - main_window->yorg;
   /* set "origin" to window rel pos */
   wm_prpos (main_window,
             main_window->wstat->ptpsx,
             main_window->wstat->ptpsy
            ); /* old window position */
   wm_wdraw (main_window);                  /* and draw */



}
/*
** List_Select : color_code  : for paper and ink
**               title       : a string used as a title for the popup window
**               explanation : a text explaining the list
**               status_list : the initial and final states of each item
**               ...         : a string, each describing a possible option
**
** return value:
**              number of selected items
**
*/
long List_Select(
                 const colourSet * color_code,
                 const char * title,
                 const char * explanation,
                 const long   nitem,
                       char * status_list,
                 const char * litm0, ...
                )
{
   va_list nxlitm;
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;


   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;
   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };

   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;
   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);


   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infw[2].ysize = infx[0].ysize = 12 + y_expl * 10;

   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;

   x=y=item_width=0;
   for(va_start(nxlitm, status_list),i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=va_arg(nxlitm,char *);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width,window_width,&vertical, &horizon, &alist, bord_x, 30+ y_expl*10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.uback = color_code->unavailable_paper;
   ww.uink  = color_code->unavailable_ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl*10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

   for(i=0;i<nitem;i++)
   {
   ws->litem[i] = (char)status_list[i];
   }
   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   ret_value = 0;
   for(i=0;i<nitem;i++)
   {
   if (WSI_SLCT & (status_list[i] = ws->litem[i]) )
       {
       ret_value++;
       }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);
   return ret_value;


}


/*
** Radio_Select : color_code  : for paper and ink
**                initial     : the radio button initialy selected
**                title       : a string used as a title for the popup window
**                explanation : a text explaining the choice
**                nitem       : the number of radio button
**                ...         : a string, each describing a radio button
**
** return value:
**              -1 : ESC was used to exit the window
**              n  : on exit, radio button n was selected
**
*/
long Radio_Select(
                  const colourSet * color_code,
                  const long        initial,
                  const char *      title,
                  const char *      explanation,
                  const long        nitem,
                  const char *      litm0, ...
                 )
{
   va_list nxlitm;
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;


   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };

   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;
   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);


   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infw[2].ysize = infx[0].ysize = 10 + y_expl* 10;
   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;

   x=y=item_width=0;
   for(va_start(nxlitm, nitem),i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=va_arg(nxlitm,char *);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width,window_width,&vertical, &horizon,
              &aradio, bord_x, 30+ y_expl*10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl*10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

   ws->litem[initial] = (char)WSI_SLCT;

   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   ret_value = -1;
   for(i=0;i<nitem;i++)
   {
      if (ws->litem[i] & WSI_SLCT)
      {
         ret_value = i;
         i = nitem;
      }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);
   return ret_value;
}

/*
** Radio_Range_Select : color_code  : for paper and ink
**                      initial     : initially set choice
**                      title       : a string used as a title for the
**                                    popup window
**                      explanation : a text explaining the choice
**                      mini        : the number on the minimal radio buttons
**                      maxi        : the number on the maximal radio buttons
**                      step        : the step between radio buttons
**
**
** return value:
**              -1 : ESC was used to exit the window
**               n : on exit, radio button n was selected
*/
long Radio_Range_Select(
                 const colourSet * color_code,
                 const long        initial,
                 const char *      title,
                 const char *      explanation,
                 const long        mini,
                 const long        maxi,
                 const long        step
                )
{
   char tmp[20];
   long i,ll,li,la,n;
   char ** array;
   n = ((maxi-mini)/step) + 1;
   if (n<2)
   {
      return -1;
   }
   sprintf(tmp,"%d",mini);
   li = strlen(tmp);
   sprintf(tmp,"%d",maxi);
   la = strlen(tmp);
   ll = la>li ? la:li;
   ll++;
   array = malloc(n*sizeof(char *));
   if (!array)
   {
      return -1;
   }
   for(i=0;i<n;i++)
   {
      array[i]= malloc(ll);
      if (!array[i])
      {
         for(;i;i--)
         {
            free(array[i-1]);
         }
         free(array);
         return -1;
      }
      sprintf(array[i],"%d",mini+i*step);
   }
   la=Radio_Select_Array(color_code,initial,title,explanation,n,array);
   for(i=0;i<n;i++)
   {
      free(array[i]);
   }
   free(array);
   return la;
}

/*
** List_Select_Array : color_code  : for paper and ink
**                     title       : a string used as a title for the
**                                   popup window
**                     explanation : a text explaining the list
**                     nitem       : the number of list items
**                     status_list : the initial and final states of each item
**                     array       : an array of strings, each describing
**                                   a possible option
**
** return value:
**              number of selected items
**
*/

long List_Select_Array(
                 const colourSet * color_code,
                 const char *      title,
                 const char *      explanation,
                 const long        nitem,
                       char *      status_list,
                 const char **     array
                )
{
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;


   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;
   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;
   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);


   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infw[2].ysize = infx[0].ysize = 12 + y_expl * 10;

   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;

   x=y=item_width=0;
   for(i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=(char *)(array[i]);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width,window_width,&vertical, &horizon,
              &alist, bord_x, 30+ y_expl*10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.uback = color_code->unavailable_paper;
   ww.uink  = color_code->unavailable_ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl*10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

   for(i=0;i<nitem;i++)
   {
   ws->litem[i] = (char)status_list[i];
   }
   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   ret_value = 0;
   for(i=0;i<nitem;i++)
   {
   if (WSI_SLCT & (status_list[i] = ws->litem[i]) )
       {
       ret_value++;
       }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);
   return ret_value;


}

/*
** Radio_Select_Array : color_code  : for paper and ink
**                      initial     : initially set choice
**                      title       : a string used as a title for the
**                                    popup window
**                      explanation : a text explaining the choice
**                      nitem       : the number of radio buttons
**                      array       : an array of strings, each describing
**                                    a radio button
**
** return value:
**              -1 : ESC was used to exit the window
**              n  : on exit, radio button n was selected
**
*/
long Radio_Select_Array(
                  const colourSet * color_code,
                  const long        initial,
                  const char *      title,
                  const char *      explanation,
                  const long        nitem,
                  const char **     array
                 )
{
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   struct WM_litm * litem;
   short window_width;
   short item_width;
   short x,y;
   char * cursor;
   long curs_len;
   long vertical;
   long x_expl;
   long y_expl;


   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };

   static struct WM_info infx[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     0,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     NULL}              /* *pobj                pointer to object */

    ,{-1}                    /* end of array */
   };
   
   static struct WM_infw infw[3+1] =  /* information window */
   {
    {0,14,          /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,0,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {0,10,          /* xsize, ysize         size */
     bord_x,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{0,10,          /* xsize, ysize         size */
     bord_x,14,             /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     infx}                  /* *pobj                pointer to object list */
 
    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     3,1,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };
   ws = malloc(sizeof(struct WM_wstat)+nitem);
   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;



   char_size = Get_CharSize();

   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   litem = calloc(nitem+1,sizeof(WM_litm_t));

   litem[nitem].xsize = -1; /* end of list */
   string_length = strlen(title);
   titre = malloc(sizeof(JG_text)+string_length);
   QD_STXT((*titre),title,string_length);

   info[0].pobj = titre;
   window_width = string_length * char_size + 2 *(bord_x);
   info[0].attr.t.ink = color_code->ink;
   info[0].xsize = window_width;
   infw[1].xsize = window_width;

   infw[1].papr = color_code->paper;
   infw[0].papr = color_code->filling;
   string_length = strlen(explanation);

   text_size(explanation, &x_expl, &y_expl);
   explain = malloc(sizeof(QD_text_t)+string_length);
   QD_STXT(((*explain)),explanation,string_length);
   infx[0].pobj = explain;
   string_length = x_expl * char_size + 2 *(bord_x);


   if (window_width < string_length )
   {
      window_width = string_length;
   }

   infx[0].xsize = string_length - 2*(bord_x);
   infw[2].ysize = infx[0].ysize = 10 + y_expl* 10;
   infx[0].attr.t.ink = color_code->ink;

   infw[2].papr = color_code->paper;

   x=y=item_width=0;
   for(i=0;i<nitem; i++)
   {
      JG_text * toto;
      cursor=(char *)(array[i]);
      curs_len= strlen(cursor);
      litem[i].pobj= toto = malloc(curs_len+sizeof(JG_text));
      ws->litem[i]= 0;
      QD_STXT((*toto), cursor, curs_len);

      if (curs_len*char_size >item_width)
      {
         item_width = curs_len * char_size;
      }
   }

   /* now, let's place the loose item */
   item_width += 4; /* allow for border */

   place_item(nitem,litem,char_size,item_width,window_width,&vertical, &horizon,
              &aradio, bord_x, 30+y_expl*10);

   if (window_width < (horizon * (bord_x + item_width) + (bord_x) * 2 ) )
   {
   window_width = horizon * (item_width+bord_x) + (bord_x) * 2 ;
   }
   ww.ninfo = 5;
   ww.ninob = 2;
   ww.pinfo = infw;
   ww.nlitm = nitem;
   ww.plitm = litem;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = window_width ;
   ww.ysize = vertical * 14 + 32 + y_expl*10;
   ww.xorg = window_width /2;
   ww.yorg = 26;
   ww.curc = color_code->surround ;


   infw[1].xorg = (window_width - info[0].xsize) / 2;
   infw[0].xsize = window_width;
   infw[2].xsize = window_width - infw[2].xorg;

   ws->litem[initial] = (char)WSI_SLCT;

   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
      };
   }
   ret_value = -1;
   for(i=0;i<nitem;i++)
   {
      if (ws->litem[i] & WSI_SLCT)
      {
         ret_value = i;
         i = nitem;
      }
   }
   wm_cluns(&ww);

   for(i=0;i<nitem;i++)
   {
      free(litem[i].pobj);
   }
   free(litem);
   free(titre);
   free(explain);
   free(ws);

   return ret_value;
}



/*
** Check_Size : window : the purported window definition
**
** return value:
**              0 : such a window can be drawn
**              !0 : such a window cannot be fitted on the current screen/application
**
*/
long Check_Size(
                const struct WM_wwork * window
               )
{
   WM_wsiz_t array;
   chanid_t chanid;

   chanid = window->chid;

   iop_flim(chanid, -1L, &array);

   if (
        (window->xsize > array.xsize)
    ||  (window->ysize > array.ysize)
      )
   {
       return -1;
   }
   else
   {
       return 0;
   }
}

/*
** int Get_CharSize ()
**
** return value:
**               the width of a caracter in pixel, in the current mode
**               (6 for mode 4, 12 for mode 8)
**
*/
int Get_CharSize()
{
   short mode,type;
   mode = -1;
   type = -1;
   mt_dmode(&mode, &type);

   switch(mode)
   {
   case 8:
      return 12;
      break;
   default:
      return 6;
      break;
   }
}

/*
** DefaultColourSet :
**
** return value:
**              a pointer to the default colour set (configurable via config)
*/
static colourSet MyPrivateSet;
colourSet * DefaultColourSet(
              )
{
   MyPrivateSet.paper = jg_paper;
   MyPrivateSet.ink = jg_ink;
   MyPrivateSet.border = jg_border;
   MyPrivateSet.filling = jg_filling;
   MyPrivateSet.surround = jg_surround;
   MyPrivateSet.selection_paper = jg_spaper;
   MyPrivateSet.selection_ink = jg_sink;
   MyPrivateSet.button_border = jg_bborder;
   MyPrivateSet.button_paper = jg_bpaper;
   MyPrivateSet.button_ink = jg_bink;
   MyPrivateSet.unavailable_paper = jg_upaper;
   MyPrivateSet.unavailable_ink = jg_uink;
   MyPrivateSet.info_ink = jg_iink;
   MyPrivateSet.info_paper = jg_ipaper;

   return ((colourSet*)&MyPrivateSet);
}

/*
** DisplayXSize
**
** return value: an unsigned int which is the max X value for the current display
**
*/
unsigned int DisplayXSize(
               )
{
   unsigned int x;
   char string[21];
   int err;

   for(err=-1,x=4096;(x>0)&&(err<0);x-=4)
   {
      sprintf(string,"scr_2x1a%dx0",x);
      err=io_open(string,0);
   }
   if (!(err<0))
   {
      io_close(err);
      x+=8;
   }
   return x;
}


/*
** DisplayYsize
**
** return value: an unsigned int which is the max Y value for the current display
**
*/
unsigned int DisplayYSize(
               )
{
   unsigned int y;
   char string[21];
   int err;

   for(err=-1,y=4096;(y>0)&&(err<0);y-=4)
   {
      sprintf(string,"scr_2x%da0x0",y);
      err=io_open(string,0);
   }
   if (!(err<0))
   {
      io_close(err);
      y+=4;
   }
   return y;
}

/*
** SetWindowColour : ww  : the window definition
**                   col : the colour set to apply
**
*/

void SetWindowColour(struct WM_wwork * ww, colourSet * col)
{
   ww->borc =  col->border;
   ww->papr =  col->paper;
   ww->curc =  col->surround;
   ww->uink =  col->unavailable_ink;
   ww->uback = col->unavailable_paper;
   ww->aink = col->ink;
   ww->aback = col->paper;
   ww->sink = col->selection_ink;
   ww->sback = col->selection_paper;

}

/*
** SetInfoColour : info : the info window definition
**                 col  : the colour set to apply
**
*/

void SetInfoColour(struct WM_infw *info, colourSet * col)
{
   struct WM_info * obj;

   info->papr = col->info_paper;

   for(obj = info->pobl;obj && (obj->xsize > 0);obj++)
   {
      if (obj->type == TYP_TEXT)
      {
         obj->attr.t.ink = col->info_ink;
      }
   }
}

/*
**
** LimitGeometry : ww   : the window definition
**                 maxX : the maximal width of the display
**                 maxY : the maximal heigth of the display
**
*/
void LimitGeometry(
                   struct WM_wwork * ww,
                   const unsigned int maxX,
                   const unsigned int maxY
                  )
{
   WM_wscale_t * tabl;
   unsigned int shadow;
   unsigned int bord;
   unsigned int realX;
   unsigned int realY;

   tabl   = ww->wscale;
   shadow = ww->flag & 0x00FF;  /* ignore top byte   */
   bord   = ww->borw & 0x0FFF; /* ignore top nibble */
#define BORDER_X_FACTOR 4
#define BORDER_Y_FACTOR 2
#define SHADOW_X_FACTOR 4
#define SHADOW_Y_FACTOR 3

   realX = maxX - (bord * BORDER_X_FACTOR) - (shadow * SHADOW_X_FACTOR);
   realY = maxY - (bord * BORDER_Y_FACTOR) - (shadow * SHADOW_Y_FACTOR);

   for(;tabl->xmax > realX; tabl->xmax -= tabl->xinc);
   for(;tabl->ymax > realY; tabl->ymax -= tabl->yinc);
}
